<?php 
// +-----------------------------------------------------------------------+
// | Stereo - a Piwigo Plugin                                              |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2010 philippe Brangier                                   |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
add_event_handler('render_element_content', 'Stereo_change_picture', 40, 2 );
add_event_handler('get_admin_plugin_menu_links', 'Stereo_plugin_admin_menu');

define('STEREO_VER' , '2.0.b');
global $conf, $stereo;

// stereo plugin configuration
$stereoSerialized  = @file_get_contents( $conf['local_data_dir'].'/plugins/'.STEREO_DIR.'.dat');
if ($stereoSerialized!==false) $stereo = unserialize($stereoSerialized);
if (!isset($stereo['version']) or  $stereo['version'] != STEREO_VER) 
{
	$stereo['version'] = STEREO_VER;
	if (!isset($stereo['ext'])) 			$stereo['ext'] = 'jps'; 
	if (!isset($stereo['menuheight'])) 		$stereo['menuheight'] = '20';
	if (!isset($stereo['containerheight'])) $stereo['containerheight'] = '';
	if (!isset($stereo['containerwidth'])) 	$stereo['containerwidth'] = '';
	if (!isset($stereo['allowFullScreen'])) $stereo['allowFullScreen'] = 'true';
	if (!isset($stereo['fixedwidth'])) 		$stereo['fixedwidth'] = '';
	if (!isset($stereo['fixedheight'])) 	$stereo['fixedheight'] = '';
	if (!isset($stereo['showhelp'])) 		$stereo['showhelp'] = 'true';
	if (!isset($stereo['helpbuttonblock'])) $stereo['helpbuttonblock'] = 'navButtons';
	if (!isset($stereo['helpbuttonposition'])) $stereo['helpbuttonposition'] = 'right';
	$dir = $conf['local_data_dir'].'/plugins/';
	@mkdir($dir);
	$file = fopen( $dir.STEREO_DIR.'.dat', 'w' );
	fwrite($file, serialize($stereo));
	fclose( $file );
}

  // add our file extension in the global config
$conf['file_ext'] = array_merge($conf['file_ext'],(array)$stereo['ext']);
$conf['picture_ext'] = array_merge($conf['picture_ext'],(array)$stereo['ext']);

function Stereo_plugin_admin_menu($menu)
{
	array_push($menu, array(
				'NAME' => 'Stereo', 
				'URL' => get_admin_plugin_menu_link(STEREO_PATH.'/config.php'), 
			));
	return $menu;
}  

function Stereo_change_picture($content, $image)
{
	global $conf, $stereo, $template, $page;
	//
	$extension = strtolower(get_extension($image['file']));
	if ($extension !== $stereo['ext'])
		{ return $content; }
	if (!isset($image['image_url']) or !empty($content))
	{ // nothing to do or someone hooked us - so we skip;
		return $content;
	}

	$template->set_filenames(array('stereo_content' => dirname(__FILE__) . '/stereo.tpl') );
 
	// compute display size
	if ( $stereo['fixedheight'] === '' ) { 
		$stereo['containerheight'] = $image['height'] + $stereo['menuheight'];
	}
	else {
		$stereo['containerheight'] = $stereo['fixedheight'] + $stereo['menuheight']; 
	}
	if ( $stereo['fixedwidth'] === '' ) { 
		$stereo['containerwidth'] = $image['width'];
	}
	else {
		$stereo['containerwidth'] = $stereo['fixedwidth']; 
	}

	// is high def available ?   if ( !isset($page['slideshow']) and isset($image['high_url']) )
	if ( !$page['slideshow'] and isset($image['high_url']) )
	{
		$uuid = uniqid(rand());
		$template->assign(
			'high',
			array(
				'U_HIGH' => $image['high_url'],
				'UUID'   => $uuid,
			)
		);
	}
	$template->assign( 
		array(
			'PHPWG_ROOT_PATH' => PHPWG_ROOT_PATH, 
			'STEREO_PATH' => STEREO_PATH, 
			'SRC_IMG'     => $image['element_url'],
			'stereo' => $stereo,
		)
	);

	load_language('plugin.lang', dirname(__FILE__).'/');
	return $template->parse('stereo_content', true);
} 
?>